# AttributeType (ARX GUI Documentation)

org.deidentifier.arx

## Class AttributeType

- java.lang.Object
- - org.deidentifier.arx.AttributeType

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable
  Direct Known Subclasses:
    AttributeType.Hierarchy, AttributeType.MicroAggregationFunction

      public class AttributeType
      extends java.lang.Object
      implements java.io.Serializable, java.lang.Cloneable

  Represents an attribute type.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `AttributeType.Hierarchy` This class implements a generalization hierarchy.
    `static class` | `AttributeType.MicroAggregationFunction` This class is used to define aggregate functions for microaggregation.
    `static class` | `AttributeType.MicroAggregationFunctionDescription` This class describes a microaggregation function

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static int` | `ATTR_TYPE_ID` Constant for type ID.
    `protected static int` | `ATTR_TYPE_IS` Constant for type IN.
    `protected static int` | `ATTR_TYPE_QI` Constant for type QI.
    `protected static int` | `ATTR_TYPE_SE` Constant for type SE.
    `static AttributeType` | `IDENTIFYING_ATTRIBUTE` Represents an identifying attribute.
    `static AttributeType` | `INSENSITIVE_ATTRIBUTE` Represents an insensitive attribute.
    `protected static int` | `MASK` The mask.
    `static AttributeType` | `QUASI_IDENTIFYING_ATTRIBUTE` Represents a quasi-identifying attribute.
    `static AttributeType` | `SENSITIVE_ATTRIBUTE` Represents a sensitive attribute.
    `protected static int` | `SHIFT` The shift.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AttributeType` | `clone()`
    `protected int` | `getType()` Returns the type identifier.
    `static java.util.List<AttributeType.MicroAggregationFunctionDescription>` | `listMicroAggregationFunctions()` Lists all available microaggregation functions
    `java.lang.String` | `toString()` Returns a string representation.

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### SHIFT

          protected static final int SHIFT

      The shift.
      See Also:
        Constant Field Values

    - #### MASK

          protected static final int MASK

      The mask.
      See Also:
        Constant Field Values

    - #### ATTR_TYPE_QI

          protected static final int ATTR_TYPE_QI

      Constant for type QI.
      See Also:
        Constant Field Values

    - #### ATTR_TYPE_SE

          protected static final int ATTR_TYPE_SE

      Constant for type SE.
      See Also:
        Constant Field Values

    - #### ATTR_TYPE_IS

          protected static final int ATTR_TYPE_IS

      Constant for type IN.
      See Also:
        Constant Field Values

    - #### ATTR_TYPE_ID

          protected static final int ATTR_TYPE_ID

      Constant for type ID.
      See Also:
        Constant Field Values

    - #### IDENTIFYING_ATTRIBUTE

          public static AttributeType IDENTIFYING_ATTRIBUTE

      Represents an identifying attribute.

    - #### SENSITIVE_ATTRIBUTE

          public static AttributeType SENSITIVE_ATTRIBUTE

      Represents a sensitive attribute.

    - #### INSENSITIVE_ATTRIBUTE

          public static AttributeType INSENSITIVE_ATTRIBUTE

      Represents an insensitive attribute.

    - #### QUASI_IDENTIFYING_ATTRIBUTE

          public static AttributeType QUASI_IDENTIFYING_ATTRIBUTE

      Represents a quasi-identifying attribute.

  - ### Method Detail

    - #### listMicroAggregationFunctions

          public static java.util.List<AttributeType.MicroAggregationFunctionDescription> listMicroAggregationFunctions()

      Lists all available microaggregation functions
      Returns:

    - #### clone

          public AttributeType clone()

      Overrides:
        `clone` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Returns a string representation.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        the string

    - #### getType

          protected int getType()

      Returns the type identifier.
      Returns:
        the type